LeetCode.970-强大的整数(Powerful Integers)

这是悦乐书的第367次更新,第395篇原创

01 看题和准备

今天介绍的是LeetCode算法题中Easy级别的第229题(顺位题号是970)。给定两个正整数xy,如果对于某些整数i >= 0j >= 0等于x^i + y^j,则整数是强大的。

返回值小于或等于bound的所有强大整数的列表。

你可以按任何顺序返回答案。在你的答案中,每个值最多应出现一次。例如:

输入:x = 2,y = 3,bound = 10
输出:[2,3,4,5,7,9,10]
说明:
2 = 2^0 + 3^0
3 = 2^1 + 3^0
4 = 2^0 + 3^1
5 = 2^1 + 3^1
7 = 2^2 + 3^1
9 = 2^3 + 3^0
10 = 2^0 + 3^2

输入:x = 3,y = 5,bound = 15
输出:[2,4,6,8,10,14]

注意

  • 1 <= x <= 100
  • 1 <= y <= 100
  • 0 <= bound <= 10^6

02 第一种解法

直接翻译题目即可,没有什么特殊的技巧,但是需要注意一点,因为判断条件时x或者y的几次方小于bound,如果x或者y为1的时候,1的任何次方都会是1,会一直小于bound,会造成死循环。

public List<Integer> powerfulIntegers(int x, int y, int bound) {
    Set<Integer> set = new HashSet<Integer>();
    for (int i=0; Math.pow(x, i) < bound; i++) {
        for (int j=0; Math.pow(y, j) < bound; j++) {
            int sum = (int)Math.pow(x, i)+(int)Math.pow(y, j);
            if (sum <= bound) {
                set.add((int)sum);
            }
            // y等于1时,容易造成死循环,要结束掉
            if (y == 1) {
                break;
            }
        }
        // x等于1时,容易造成死循环,要结束掉
        if (x == 1) {
            break;
        }
    }
    return new ArrayList<>(set);
}

03 第二种解法

针对上面第一种解法,我们也可以不借助Math类的pow方法,用累计相乘替代,思路都是一样的。

public List<Integer> powerfulIntegers2(int x, int y, int bound) {
    Set<Integer> set = new HashSet<Integer>();
    for (int i=1; i<bound; i *= x) {
        for (int j=1; j<bound; j *= y) {
            if (i+j <= bound) {
                set.add(i+j);
            }
            if (y == 1) {
                break;
            }
        }
        if (x == 1) {
            break;
        }
    }
    return new ArrayList<>(set);
}

04 小结

算法专题目前已连续日更超过七个月,算法题文章235+篇,公众号对话框回复【数据结构与算法】、【算法】、【数据结构】中的任一关键词,获取系列文章合集。

以上就是全部内容,如果大家有什么好的解法思路、建议或者其他问题,可以下方留言交流,点赞、留言、转发就是对我最大的回报和支持!

原文地址:https://www.cnblogs.com/xiaochuan94/p/11105760.html

时间: 2024-10-07 00:20:28

LeetCode.970-强大的整数(Powerful Integers)的相关文章

[Swift Weekly Contest 118]LeetCode970. 强整数 | Powerful Integers

Given two non-negative integers x and y, an integer is powerful if it is equal to x^i + y^j for some integers i >= 0 and j >= 0. Return a list of all powerful integers that have value less than or equal to bound. You may return the answer in any ord

【Leetcode_easy】970. Powerful Integers

problem 970. Powerful Integers solution: class Solution { public: vector<int> powerfulIntegers(int x, int y, int bound) { unordered_set<int> tmp; for(int a=1; a<bound; a*=x)// { for(int b=1; a+b<=bound; b*=y) { tmp.insert(a+b);// if(y==1

leetcode——Reverse Integer 反转整数数字(AC)

Reverse digits of an integer. Example1: x = 123, return 321 Example2: x = -123, return -321 这个题比较简单,考虑特殊情况如12000,注意检查反转后数字是否会越界溢出.代码如下: class Solution { public: int reverse(int x) { bool minus = false; short int splitNum[10]; int i = 0, j = 0; unsign

LeetCode:罗马数字转整数【13】

LeetCode:罗马数字转整数[13] 题目描述 罗马数字包含以下七种字符: I, V, X, L,C,D 和 M. 字符 数值 I 1 V 5 X 10 L 50 C 100 D 500 M 1000 例如, 罗马数字 2 写做 II ,即为两个并列的 1.12 写做 XII ,即为 X + II . 27 写做  XXVII, 即为 XX + V + II . 通常情况下,罗马数字中小的数字在大的数字的右边.但也存在特例,例如 4 不写做 IIII,而是 IV.数字 1 在数字 5 的左边

LeetCode 第7题 整数反转

LeetCode 第7题 整数反转 题目描述 给出一个 32 位的有符号整数,你需要将这个整数中每位上的数字进行反转. 整体思路 这道题在LeetCode的题目中是非常简单的,尤其是用Python来解决.我们都知道在Python中int类型和str类型是可以相互转换的:int(str) 或者 str(int).因此这道题中,我们仅需要将input中的int类型转换为str类型然后翻转字符串即可. 翻转字符串我们用到的方法是str[::-1].在这个语句中,'-1'指的是step(步长)的意思,取

Leetcode 970. Powerful Integers

Brute Force(暴力) class Solution(object): def powerfulIntegers(self, x, y, bound): """ :type x: int :type y: int :type bound: int :rtype: List[int] """ ans=[] for i in range(20): for j in range(20): a=x**i+y**j if a<=bound:

leetcode第28题--Divide Two Integers

Divide two integers without using multiplication, division and mod operator. 分析:题目意思很容易理解,就是不用乘除法和模运算求来做除法,很容易想到的一个方法是一直做减法,然后计数,超时.在网上找到一种解法,利用位运算,意思是任何一个整数可以表示成以2的幂为底的一组基的线性组合,即num=a_0*2^0+a_1*2^1+a_2*2^2+...+a_n*2^n.基于以上这个公式以及左移一位相当于乘以2,我们先让除数左移直到

通过位运算求两个数的和(求解leetcode:371. Sum of Two Integers)

昨天在leetcode做题的时候做到了371,原题是这样的: 371. Sum of Two Integers Calculate the sum of two integers a and b, but you are not allowed to use the operator + and -. Example: Given a = 1 and b = 2, return 3. 因为之前完全没有在实际练习中使用过位运算,所以刚看到这道题目的时候我的第一反应是 1.用乘除代替加减,但是一想,

LeetCode Reverse Integer 反转整数

1 class Solution { 2 public: 3 int reverse(int x) { 4 int e,s,num,k=0; 5 num=x; 6 e=0; 7 if(x<0) 8 num=-1*x; 9 while( num!=0 ){ 10 s=num%10; 11 e=e*10+s; 12 num=num/10; 13 k++; 14 } 15 if(x<0) 16 return -e; 17 else 18 return e; 19 } 20 }; 题意: Exampl